package net.zmobile.ui;

import java.util.Vector;

import javax.microedition.lcdui.Graphics;

import net.zmobile.ZMobile;
import net.zmobile.ge.ZRect;
import net.zmobile.ui.layout.ZFillLayout;

public class ZDialog extends ZContainer {

	public Object dialogMtuex = new Object();

	public ZDialog() {
		this.setFoucus(true);
		this._x = 20;
		this._y = 20;
		this._w = 200;
		this._h = 200;

		resize();
		ZLabel label = new ZLabel(
				"With this generator you can easily make text wrap around images! Simply provide an url for an image, the text, and how you would this text be wrapped around ...");
		add(label);
		addBtn();
		this.setLayout(new ZFillLayout(ZFillLayout.V_LAYOUT));
	}

	public void addBtn() {
		ZButton btnNo = new ZButton("Yes");
		// btnNo.setBounds(_x+60, _y+50, 20, 20);
		btnNo.addListener(ZMobile.EVENT_KEY_SELECT_RELESE, new Listener(){

			public void event(int x, int y, int key) {
				try {
					synchronized (ZFormCanvas.dialogMetux) {
						ZFormCanvas.dialogMetux.notify();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				ZForm.uiStack.pop();
				System.out.println("*****");				
			}
			
		});
		this.add(btnNo);
	}

	public void draw(Graphics g) {
		g.setClip(_x - 1, _y - 1, _w + 2, _h + 2);
		g.setColor(ZConstants.TILTE_BACK_COLOR);
		g.fillRect(_x, _y, _w, _h);

		g.setColor(0xff0000);
		// g.fillRect(_x, _y, _w, ZConstants.TILTE_HEIGHT);

		g.setColor(0x0);
		g.setClip(_x - 1, _y - 1, _w + 2, _h + 2);
		g.drawRect(_x, _y, _w, _h);

		g.setColor(0x0000ff);
		g.drawRect(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - 2 * ZMobile.GRAP,
				_h - 2 * ZMobile.GRAP);
		super.draw(g);
		// g.drawRect(_x + ZMobile.GRAP + 1, _y + ZMobile.GRAP + 1, _w - 2
		// * ZMobile.GRAP - 2, _h - 2 * ZMobile.GRAP - 2);
	}

	private ZForm getZForm() {
		for (int i = ZForm.uiStack.size() - 1; i >= 0; i--) {
			if (ZForm.uiStack.elementAt(i) instanceof ZForm) {
				return (ZForm) ZForm.uiStack.elementAt(i);
			}
		}
		return new ZForm();
	}

	public void show() {
		if (!ZForm.uiStack.contains(this))
			ZForm.uiStack.push(this);
		ZForm zform = getZForm();
		synchronized (ZFormCanvas.mainThreadMetux) {
			ZFormCanvas.mainThreadMetux.notify();
		}
		ZForm.instance.repaint();
		try {
			synchronized (ZFormCanvas.dialogMetux) {
				ZFormCanvas.dialogMetux.wait();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void resizeClientBounds() {
		_client_x = _x;
		_client_y = _y + ZConstants.TILTE_HEIGHT + 1;

		_client_w = _w;
		_client_h = _h - ZConstants.TILTE_HEIGHT - 1;
	}

	public void resize() {
		resizeClientBounds();
		if (_lManger != null) {
			_lManger.resize(new ZRect(_client_x, _client_y, _client_w,
					_client_h), _components);
		}
	}

	Vector dialogListeners = new Vector();

	public void addListener(Listener listener) {
		dialogListeners.addElement(listener);
	}
}
